DJohn - Distributed John
=========================

Es un programa para paralelizar el crackeo en modo fuerza bruta hecho
con John the Ripper [http://www.openwall.com/john].

Fue testeado en Linux x86 [Debian, Mandrake, Red Hat], FreeBSD y Solaris.
Nota: Como ya no tengo acceso a una mquina con Solaris, esta nueva versin de
DJohn puede no compilar en Solaris. Si no llegara a compilar y quers ayudar
por favor mandame un patch.

Fue desarrollado por Luis Parravicini <luis@ktulu.com.ar>. Podes bajar la
ultima version de http://ktulu.com.ar


Introduccion
-------------

La coordinacion del crackeo es hecha por un servidor (djohnd). Divide a
todo el dominio de claves a probar en paquetes de trabajo. Un paquete
contiene la primera y la ultima palabra a probar (inclusive). Los clientes
piden un paquete al servidor, lo procesan y devuelven los resultados
obtenidos.

Actualmente, djohn tendria que correr sobre una red donde se pueda confiar
en los clientes. Por lo que por ahora, podes DOSear al servidor facilmente.
Tambien, los clientes se asumen que son todos iguales (o muy similares en
cuanto a poder de CPU) ya que la cantidad de trabajo entregada a cada
cliente es la misma para todos.


Instalacion
-----------

Utilizando make lo compilas y luego "make install" para instalarlo.
"make install" lo instala en /usr/local/bin y copia los archivos de
internacionalizacion a /usr/share/locale/
Sin "make install" podes usarlo, pero no vas a poder utilizarlo en castellano.


djohn en castellano
-------------------

John tiene soporte para internacionalizacion utilizando gettext. Por default
el programa esta en ingles, pero seteando alguna de las variables LANGUAGE,
LC_ALL,LC_MESSAGES,LANG) a "es" (por ejemplo en bash: export LANGUAGE=es)
muestra todos sus mensajes en castellano. Tene en cuenta que las variables
anteriores tienen prioridades (con LANGUAGE teniendo la prioridad mas alta y
LANG la mas baja) asi que, por ejemplo, si seteas LC_MESSAGES pero LANGUAGE ya
tiene otro valor (diferente a es) entonces no va a andar. Si no estas seguro
setea LANGUAGE y listo.


djohnd (el servidor)
--------------------

La primera vez que corres el servidor, necesitas pasarle los diferentes
parametros para el crackeo (abajo esta la salida de djohnd -h).

usage: djohnd [options]
-b ip : binds the server socket to 'ip'
-c charset : sets the charset
-f first_word : sets the first word to be tried
-l last_word : sets the last word to be tried
-t ttl : sets the packet's ttl (in seconds) (default: 600)
-w n : sets the amount of words per packet (default: 10000)
-r : restore previous session
-v : be verbose


Voy a explicar nada mas que -c y -r, el resto me parece que con la ayuda de
arriba es suficiente para el resto de las opciones. El conjunto de caracteres
es una lista de los caracteres validos que un password puede contener, y se
pueden especificar rangos (por ejemplo: a-z). Para incluir el - como un
caracter del conjunto, ponelo primero o ultimo. Por ejemplo, para especificar
todas letras minusculas, todos los digitos, el guien bajo y el signo igual
podrias usar "a-z0-9_=".

Luego de que el servidor arranque, se queda escuchando en el puerto 40000/udp.
Todas las opciones son guardadas en djohn.restore cuando el servidor recibe
SIGTERM, SIGQUIT y SIGINT. De esta manera se puede resumir mas tarde el crackeo
usando -r la proxima vez que corras el servidor.

Todas las claves enviadas por los clientes son almacenadas en djohn.pot sin
chequear por duplicados.


djs
----

Muestra el estado del servidor pudiendo cambiar el formato de los datos mostrados. Se debe correr en la misma maquina donde esta corriendo el servidor.


djohn (el cliente)
------------------

El cliente necesita saber donde encontrar los siguientes archivos:
1. John the Ripper
2. john-ini. Este es una copia del john.ini. Es usado como una plantilla
para crear un nuevo john.ini con un modo externo llamado dJohn que se
encarga de probar todas las palabras de un paquete enviado por el servidor.
3. Los archivos de passwords (se asume que son los mismos para todos los
clientes y los nombres de los archivos comienzan con "passwd").
4. El esqueleto para crear el modo externo, en un archivo llamado dJohn.

- John The Ripper se asume que esta en el directorio actual, en un
subdirectorio llamado john/run. Esto puede cambiarse mediante la opcion
'-j'.
- john-ini, los archivos de passwords y dJohn se asumen que estan en el
directorio especificado por la opcion '-d' o, si no se uso '-d', entonces
donde apunte $DJHOME.

************************************************************************
ADVERTENCIA:
	Cada cliente debe tener su copia de John the Ripper, porque el
	cliente sobreescribe john.ini, restore y john.pot.
************************************************************************

Ahora, podes correr el cliente pasandole el nombre o el ip del servidor al
cual se va a conectar. Luego de esto deberias ver al servidor (si usaste -v)
y al cliente mandando informacion por stdout sobre los paquetes enviados /
recibidos.


Compilacion en windows:
-----------------------

Es necesario cygwin [http://www.cygwin.com] e instalar luego los siguientes paquetes: gcc, make, gettext, gettext-devel, cygipc.
Para correr djohnd es necesario habilitar los servicios de ipc corriendo "ipc-daemon2.exe" el cual pertenece al paquete cygipc.


Que algoritmos soporta?:
------------------------

El crackeo es hecho por John The Ripper, asi que los algoritmos soportados son los que john soporta. Consulta la documentacion de john para mas informacion.


modo externo dJohn:
-------------------

El modo externo usado por el cliente para crackear las claves de la unidad de
trabajo se crea utilizando como esqueleto del modo externo el contenido del
archivo "dJohn". Este esqueleto contiene algunas variables que interpreta el
cliente y son reemplazadas por su valores actuales.

Las variables son cadenas de texto entre @ (por ejemplo, para obtener la cantidad de caracteres en el conjunto de caracteres utilizarias "@charset_length@"). La siguiente lista muestra las variables que se pueden usar:


Nombre			Tipo de datos	Descripcion
charset_length		int		numero de caracteres en el conjunto de
					caracteres.
max_word		int		longitud maxima de un password.
length_word_1		int		longitud de la primera palabra de la
					unidad de trabajo.
charset			string		inicializa un arreglo de nombre
					"charset" con la primera palabra que el
					modo externo va a usar.
word_1			string		la primera palabra que el modo externo
					va a probar.
eq_word_2		string		la ultima palabra que el modo externo
					va a probar.

