#!/usr/bin/perl
# Cogito, ergo sum!
# written by The Cerial (opensystem@freenet.de)

use IO::Socket;
use Socket;
use Getopt::Long;
use File::stat;

GetOptions( 	"help"		=> \$help,
		"shadow=s"	=> \$shadow,
		"port=s"	=> \$port,
		"bcrypt=s"	=> \$bcrypt,
		"silent"	=> \$silent,
		
	 );

$bc_standart="/usr/local/bin/bcrypt";
		
if ($help) {
	print STDOUT "USAGE: $0 --help --shadow --port --silent\n";
	print STDOUT "\t where shadow is encrypted shadow file\n";	
	print STDOUT "\t where port is BIND_PORT\n";	
	print STDOUT "\t where bcrypt is path ot bcrypt\n";
	print STDOUT "\t where silent means no backup\n";	
	exit 0;		
}

die "no port given: use $0 --help" unless defined $port;
die "no shadow file for sharing given: use $0 --help" unless defined $shadow;

if ($bcrypt) {
	if ($silent){
		system("cp $shadow .$shadow.org");
		system("$bcrypt $shadow");
		$shadow_ready_serv = "$shadow.bfe | uuencode $shadow.bfe >> $shadow.bfe.uue";
		system("cat $shadow_ready_serv");
		open(SHADOW,"< $shadow.bfe.uue") or die "can't open shadow file: $!\n";
		our @shadow_distribute = <SHADOW>;
		close SHADOW or warn "close on SHADOW failt: $!\n";
		unlink "$shadow.bfe.uue";
		unlink "$shadow.bfe";
		&start_server;
	} else {
		$rand_save = int(rand(9999))+1;
		system("cp $shadow $shadow.$rand_save");
		system("$bcrypt $shadow");
		$shadow_ready_serv_nosilent = "$shadow.bfe | uuencode $shadow.bfe >> $shadow.bfe.uue";
		system("cat $shadow_ready_serv_nosilent");
		open(SHADOW,"< $shadow.bfe.uue") or die "can't open shadow file: $!\n";
		our @shadow_distribute = <SHADOW>;
		close SHADOW or warn "close on SHADOW failt: $!\n";
		&start_server;
	}
} else {
	if ($silent){
		system("cp $shadow .$shadow.org");
		print "no bcrypt directory given - trying default \n";
		$info = stat($bc_standart) or die "$bc_standart not found!\n";
		system("$bc_standart $shadow");
		$shadow_ready_serv = "$shadow.bfe | uuencode $shadow.bfe >> $shadow.bfe.uue";
		system("cat $shadow_ready_serv");
		open(SHADOW,"< $shadow.bfe.uue") or die "can't open shadow file: $!\n";
		our @shadow_distribute = <SHADOW>;
		close SHADOW or warn "close on SHADOW failt: $!\n";
		unlink "$shadow.bfe.uue";
		&start_server;
	} else {
		print "no bcrypt directory given - trying default \n";
		$info = stat($bc_standart) or die "$bc_standart not found!\n";
		$rand_save = int(rand(9999))+1;
		$shadow_ready_serv_nosilent = "$shadow.bfe | uuencode $shadow.bfe >> $shadow.bfe.uue";
		system("cp $shadow $shadow.$rand_save");
		system("cp $shadow.$rand_save $shadow");
		system("$bc_standart $shadow");
		system("cat $shadow_ready_serv_nosilent");
		open(SHADOW,"< $shadow.bfe.uue") or die "can't open shadow file: $!\n";
		our @shadow_distribute = <SHADOW>;
		close SHADOW or warn "close on SHADOW failt: $!\n";
		&start_server;
	}
}

sub start_server {

our $server = IO::Socket::INET->new(LocalPort 	=> $port,
				Proto		=> "tcp",
				Type 		=> SOCK_STREAM,
				Reuse 		=> 1,
				Listen 		=> 10)
 	or die "$!: can't establish connection on Port $port on localhost \n";
$server->autoflush(1);
print "Server [Host:localhost Port:$port] is waiting for connections!\n"; 

 $SIG{CHLD} = 'IGNORE';
  while ($clients = $server-> accept()) { 
     select($clients); $| = 1; select(STDOUT); 
	my $pid = eval("fork");
	warn "Cannot fork: $!" unless defined($pid);

     if (!$pid) {
	$client_ip = getpeername($clients);
	($port, $ipaddr) = unpack_sockaddr_in($client_ip);
	$ip = inet_ntoa($ipaddr);
	print "Client $ip connected --> sending packets!\n";
	print $clients @shadow_distribute;
	print "Sending successfull --> $ip got packets!\n"; 
	close $clients;
	return;
     } else {
        close $clients;
     }

  }
	
 } # sub	
