/*
 * This file is part of Distributed John,
 * Copyright (C) 2001-2003 by Luis Parravicini
 * http://ktulu.com.ar
 */
#include "defs.h"

/*
 * Return the size of the packet according to the action to be performed
 * or -1 on an unknown packet type.
 * It must be called after all of the other fields of the struct have
 * appropiate values.
 */
int packetsize(int action, const struct generic_packet* pkt)
{
	switch (action) {
		case GET_WORK: return GETWORK_SIZE(pkt);
		case FIRST_WORD: return FIRSTWORD_SIZE(pkt);
		case FINISH_WORK: return FINISHWORK_SIZE(pkt);
		case GET_CHARSET: return GETCHARSET_SIZE(pkt);
		case CHARSET_DATA: return CHARSETDATA_SIZE(pkt);
		case NOW_SLEEP: return SLEEP_SIZE(pkt);
		case GET_CODE: return GETCODE_SIZE(pkt);
		case CODE_DATA: return CODEDATA_SIZE(pkt);
	}
	return -1;
}
